EXTRA_CFLAGS += -I$(DRIVERINC)
EXTRA_CFLAGS += -I$(MODINC)
EXTRA_CFLAGS += -DAU13XX

ifneq ($(KERNELRELEASE),)
# call from kernel build system

# Convert mae*.c => *.o
all_mod_c := $(wildcard $(PWD)/mae???.c)
mod_o := $(patsubst %.c, %.o, $(notdir $(all_mod_c)))

obj-m := $(mod_o)

else

KERNELDIR ?= /opt/rmi-linux/db1300/src/linux
PWD       := $(shell pwd)

DRIVER_INCLUDE_PATH = $(PWD)/../.. $(PWD)/..
MOD_INCLUDE_PATH = $(PWD)/..

modules:
	$(MAKE) -C $(KERNELDIR) M=$(PWD) DRIVERINC=$(DRIVER_INCLUDE_PATH) MODINC=$(MOD_INCLUDE_PATH) modules

modules_install:
	$(MAKE) -C $(KERNELDIR) M=$(PWD) modules_install

endif

clean:
	rm -rf *.o *~ core .depend .*.cmd *.ko *.mod.c .tmp_versions Module.markers

depend .depend dep:
	$(CC) $(CFLAGS) -M *.c > .depend


ifeq (.depend,$(wildcard .depend))
include .depend
endif
